package org.commonjava.tensor.event;

import org.commonjava.maven.atlas.common.ref.ProjectVersionRef;
import org.commonjava.maven.atlas.effective.EProjectDirectRelationships;
import org.commonjava.maven.atlas.effective.ref.EProjectKey;
import org.commonjava.maven.atlas.effective.workspace.GraphWorkspace;

public class NewRelationshipsEvent
{

    private final EProjectDirectRelationships relationships;

    private final GraphWorkspace session;

    public NewRelationshipsEvent( final EProjectDirectRelationships relationships, final GraphWorkspace session )
    {
        this.relationships = relationships;
        this.session = session;
    }

    public final ProjectVersionRef getRef()
    {
        return relationships.getProjectRef();
    }

    public final EProjectDirectRelationships getRelationships()
    {
        return relationships;
    }

    public GraphWorkspace getSession()
    {
        return session;
    }

    public final EProjectKey getKey()
    {
        return relationships.getKey();
    }

}
