package org.commonjava.tensor.inject;

import javax.enterprise.context.ApplicationScoped;
import javax.enterprise.inject.Produces;
import javax.inject.Inject;

import org.commonjava.maven.atlas.effective.EGraphManager;
import org.commonjava.tensor.data.GraphWorkspaceHolder;
import org.commonjava.tensor.io.json.TensorSerializationAdapter;
import org.commonjava.web.json.ser.JsonSerializer;

@ApplicationScoped
public class TensorSerializerProvider
{

    private JsonSerializer serializer;

    @Inject
    private EGraphManager graphs;

    @Inject
    private GraphWorkspaceHolder sessionManager;

    public TensorSerializerProvider()
    {
    }

    public TensorSerializerProvider( final EGraphManager graphs, final GraphWorkspaceHolder sessionManager )
    {
        this.graphs = graphs;
        this.sessionManager = sessionManager;
    }

    @Produces
    @TensorData
    public synchronized JsonSerializer getTensorSerializer()
    {
        if ( serializer == null )
        {
            serializer = new JsonSerializer( new TensorSerializationAdapter( graphs, sessionManager ) );
        }

        return serializer;
    }

}
